#include <acknex.h>
#include <default.c>

#define _X 0
#define _Y 1

#define FALSE 0
#define TRUE 1

#define SecondInTicks 16

//ini
#define MAXPLAYERS 4

#define COUNTDOWN_ANG_FREQ 0.3
#define COUNTDOWN_SPEED 0.3


//prototypes
void DrawMainScreen();

typedef struct { 
  var position[2], velocity[2], angle, alive, roundsWon, owner, medal, medalShare;
} PLAYER;


#define OWNER_NONE 0
#define OWNER_PLAYER 1
#define OWNER_COMPUTER 2

PLAYER* Player[MAXPLAYERS];
STRING* TempString;

BMAP* bGameField=NULL;
PANEL* pGameField=NULL;
SOUND* sndCountDown;
SOUND* sndCrash;
SOUND* sndPlayerSelect;
SOUND* sndComputerSelect;
SOUND* sndSetting;
SOUND* sndStartGame;
SOUND* sndCantStartGame;
BMAP* bWinScreen;
BMAP* bMScreen;

int Rounds[5]={1,3,5,10,15},Rindex=1;

int AreaSize[6]={0,4,9,15,18,27},Aindex=3;

int Difficulty[42]={	0,		3,		75,	45,	6,		9,		2.5,
							20,	4.5,	75,	37,	6,		9,		2.5,
							37,	6,		75,	30,	6,		12,	2.7,
							53,	8,		75,	20,	6,		11.7,	3.1,
							66,	10,	75,	15,	4,		14.4,	3.7,
							77},MatchStarted,activePlayers,Dindex=2;

#define DLEVEL_TEXTPOS 0
#define DLEVEL_MSPEED 1
#define DLEVEL_SOLID 2
#define DLEVEL_GAP 3
#define ANG_STEP_AI 4
#define ANG_STEP 5
#define ANG_FREQ 6
	#define DLEVEL_MAX 7




//							clrB	clrG	clrR	lft	rght	fire	tclrB	tclrG	tclrR	txtX	txtY	Nstr	Nlen	NPosX	
var PlayerData[56]={	0,		220,	220,	30,	32,	31,	0,		190,	190,	28,	90,	0,		9,		5,			//Mr Yellow
							230,	0,		230,	36,	38,	37,	200,	0,		200,	28,	214,	9,		7,		175,		//Mr Pink
							210,	0,		0,		75,	77,	80,	180,	0,		0,		28,	340,	16,	7,		365,		//Mr Blue
							0,		180,	0,		82,	28,	83,	0,		150,	0,		9,		450,	23,	8,		515};		//Mr Green
							

#define PLAYERDATA_COLOUR 0
#define PLAYERDATA_KEYLEFT 3
#define PLAYERDATA_KEYRIGHT 4
#define PLAYERDATA_KEYFIRE 5
#define PLAYERDATA_TEXTCOLOUR 6
#define PLAYERDATA_TEXTX 9
#define PLAYERDATA_TEXTY 10
#define PLAYERDATA_NAMESTART 11
#define PLAYERDATA_NAMELENGTH 12
#define PLAYERDATA_NAMEPOSX 13
	#define MAXPLAYERDATA 14


void ix_dv(var vDebugValue,int column,var vTime)
{	
	STRING* sLocalString = str_create("poutsa");
	
	str_for_num(sLocalString,vDebugValue);
	
	var i=0;
	
	while (i<=vTime*SecondInTicks)
	{
		draw_text(sLocalString,450,column*25,vector(0,200,0));
		i+=time_step;
		wait(1);
	}
}

var RandomInt(from,to)
{
	return(from+integer(random((to+1)-from)));
}


int ColourPixel(BMAP* bBmap, var vFormat, var* vecColour,int iPosX, int iPosY, int iRadious, int bCheckPassability)
{
	int j,i=-1;
	COLOR* pixelColor={red=0;}
	
	if (	iPosX-iRadious>0 &&
			iPosY-iRadious>0 &&
			iPosX+iRadious<screen_size.x &&
			iPosY+iRadious<screen_size.y)
	while (i++<=iRadious*2)
		for (j=0;j<=iRadious*2;j++)
			if (!bCheckPassability)
				pixel_to_bmap(bBmap,iPosX-iRadious+i,iPosY-iRadious+j,pixel_for_vec(vecColour,100,vFormat));
			else
			{
				pixel_to_vec(pixelColor,NULL,vFormat,pixel_for_bmap(bBmap,iPosX-iRadious+i,iPosY-iRadious+j));
				if  (pixelColor.red==0 && pixelColor.green==0 && pixelColor.blue==0)
					return (TRUE);
			}
}



void CreateRectangle(BMAP* bBmap, VECTOR* a, VECTOR* b, VECTOR* c, VECTOR* d, int iRadious, VECTOR* vecColour)
{
	var vFormat=bmap_lock(bBmap,0);
	
	int i=a.x-1; //put me with the var, if nothing else(i'm trying to get rid of the bmap_lock/unlock functions here..)
	while (i++<=b.x)
		ColourPixel(bBmap,vFormat,vecColour,i,a.y,iRadious,FALSE);
	
	i=c.x-1;
	while (i++<=d.x)
		ColourPixel(bBmap,vFormat,vecColour,i,c.y,iRadious,FALSE);
		
	i=a.y-1;
	while (i++<=c.y)
		ColourPixel(bBmap,vFormat,vecColour,a.x,i,iRadious,FALSE);
		
	i=b.y-1;
	while (i++<=d.y)
		ColourPixel(bBmap,vFormat,vecColour,b.x,i,iRadious,FALSE);
		
	bmap_unlock(bBmap);
}


var Trace2d(BMAP* bBmap,var vFormat,PLAYER* spPlayer,int PlayerId,int distance,var angleSpectre,var* TurnOffsets,var Step)
{
	var CurrentPos[2],bFoundObstacle=FALSE,i=0,j=(integer(angleSpectre/2)*(-1))-Step;
	
	if (*TurnOffsets=0.1)
		while (j<angleSpectre/2)
			if (*TurnOffsets+=i*sign(sinv((spPlayer->angle+j)-spPlayer->angle)))
				if ((i=-1) || (j+=Step))
					if (CurrentPos[0]=spPlayer->position[0])
						if (CurrentPos[1]=spPlayer->position[1])
							while (i++<distance)
								if (vec_add(CurrentPos[_X],vec_for_angle(nullvector,vector(spPlayer->angle+j,0,0))))
									if (i>3)
										if (!ColourPixel(bGameField, vFormat, nullvector,CurrentPos[_X], CurrentPos[_Y],4-Aindex,TRUE))
											if (bFoundObstacle=TRUE)
												break;
					
	return(bFoundObstacle);
}




void PlayerFunc(PLAYER* spPlayer,int PlayerId)
{	
	var startTime=total_ticks,vFormat,bHasMoved,tickBuffer=0,pixelBuffer=0,angleBuffer=0,TurnTo,updateTime=0,Victim=-2,tempPos[2],tempPan[2];
	
	while (spPlayer->alive)
	{
		//Open Bitmap
		var vFormat=bmap_lock(bGameField,0);

		while (angleBuffer>=1 && spPlayer->owner==OWNER_PLAYER)
		{
			angleBuffer--;
			if (key_pressed(PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_KEYRIGHT])) spPlayer->angle+=Difficulty[Dindex*DLEVEL_MAX+ANG_STEP];
				else if (key_pressed(PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_KEYLEFT])) spPlayer->angle-=Difficulty[Dindex*DLEVEL_MAX+ANG_STEP];
		}
		
		while (tickBuffer>=1)
		{
			if (spPlayer->owner==OWNER_COMPUTER)
			{
				//AI
				
				//If Danger
				if (Trace2d(bGameField,vFormat,spPlayer,PlayerId,50,75,&TurnTo,12))
				{
					//Do Scan (Record all distances in 360)
					if (Trace2d(bGameField,vFormat,spPlayer,PlayerId,100,358,&TurnTo,10))
					
					//Move to angle with greatest distance
					spPlayer->angle+=Difficulty[Dindex*DLEVEL_MAX+ANG_STEP_AI]*sign(TurnTo);
				}
				//Else
				else
				{
					//Every 2.3 Seconds
					if (total_ticks-updateTime>2.3*SecondInTicks)
					{
						if (updateTime=total_ticks)
							if (Victim=-1)
								//If Random Smaller than Hostily (out of 10?)
								if (RandomInt(0,10)<6)  //6
								{
									if ((Victim=RandomInt(0,3)) || 1)
										while (Player[Victim].owner==OWNER_NONE || !Player[Victim].alive || Victim==PlayerId)
											if (Victim++>3) Victim=0;
								}
					}
					
					if (Victim>=0)
					{
						//Move towards random opponent
						if (vec_add(vec_set(tempPos,vector(Player[Victim].position[_X],Player[Victim].position[_Y],0)),vec_scale (vec_for_angle(nullvector,vector(Player[Victim]->angle,0,0)), RandomInt(75,115))))
							if (vec_sub(tempPos,vector(spPlayer.position[_X],spPlayer.position[_Y],0)))
								if (vec_to_angle(tempPan,tempPos))
									spPlayer->angle+=Difficulty[Dindex*DLEVEL_MAX+ANG_STEP_AI]*sign(sinv((tempPan[0])-spPlayer->angle));
					}
					else if (Victim==-1)
					{
						//Move in Random Direction
						spPlayer->angle+=Difficulty[Dindex*DLEVEL_MAX+ANG_STEP_AI]*sign(RandomInt(-10,10));
					}
					
				}
			}
			
			//Fix Angle
			while (spPlayer->angle>180 || spPlayer->angle<-180) spPlayer->angle-=360*sign(spPlayer->angle);
	
			//while ((abs(spPlayer->velocity[_X])<=1) && (abs(spPlayer->velocity[_Y])<=1))
				vec_add(spPlayer->velocity[_X],vec_for_angle(nullvector,vector(spPlayer->angle,0,0)));
			
			bHasMoved=FALSE;
			int i=-1;
			while (i++<=_Y)
				if (abs(spPlayer->velocity[i])>1)
				{
					spPlayer->velocity[i]-=sign(spPlayer->velocity[i]);
					spPlayer->position[i]+=sign(spPlayer->velocity[i]);
					bHasMoved=TRUE;
				}
			
			if (bHasMoved)
			{
				if (!ColourPixel(bGameField, vFormat, nullvector,spPlayer->position[_X], spPlayer->position[_Y],4-Aindex,TRUE) ||
					 spPlayer->position[_X]-(4-Aindex)<=3 ||
					 spPlayer->position[_Y]-(4-Aindex)<=3 ||
					 spPlayer->position[_X]+(4-Aindex)>=screen_size.x ||
					 spPlayer->position[_Y]+(4-Aindex)>=screen_size.y)
					if (snd_play(sndCrash, 100, 0))
						spPlayer->alive=FALSE;
		
				if (pixelBuffer++ || tickBuffer-- || 1)
					if (pixelBuffer<=Difficulty[Dindex*DLEVEL_MAX+DLEVEL_SOLID])
						ColourPixel(bGameField, vFormat, PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_COLOUR],spPlayer->position[_X], spPlayer->position[_Y],4-Aindex,FALSE);
					else if (pixelBuffer>Difficulty[Dindex*DLEVEL_MAX+DLEVEL_SOLID]+Difficulty[Dindex*DLEVEL_MAX+DLEVEL_GAP])
						pixelBuffer=0;
			}
		}
		
		//Draw head
		draw_quad(NULL,vector(spPlayer->position[_X]-(4-Aindex),spPlayer->position[_Y]-(4-Aindex),0),NULL,vector(1+((4-Aindex)*2),1+((4-Aindex)*2),0),NULL,PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_COLOUR],100,0);
		
		
		//Close Bitmap
		bmap_unlock(bGameField);
		
		
		wait(1);
		
		
		if (total_ticks-startTime<3*18)
		{
			angleBuffer+=time_frame*COUNTDOWN_ANG_FREQ;
			tickBuffer+=time_frame*COUNTDOWN_SPEED;
		}
		else
		{
			angleBuffer+=time_frame*Difficulty[Dindex*DLEVEL_MAX+ANG_FREQ];
			tickBuffer+=time_frame*Difficulty[Dindex*DLEVEL_MAX+DLEVEL_MSPEED];
		}
	}
}


STRING* GetNameFromPlayer(var PlayerId,STRING* PlayerNames)
{
	return(str_trunc(str_clip(str_cpy(TempString,PlayerNames),PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_NAMESTART]),str_len(PlayerNames)-PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_NAMESTART]-PlayerData[PlayerId*MAXPLAYERDATA+PLAYERDATA_NAMELENGTH]));
}
	

void NewMatch()
{
	//Create the gamefield
	ptr_remove(bGameField);
	ptr_remove(pGameField);
	bGameField = bmap_createblack(screen_size.x,screen_size.y,16);
	pGameField = pan_create("bmap = bGameField;flags=VISIBLE;",1);
	
	var startTime=total_ticks,winnerId=-2,i=-1,j,endTime,Medal=1,MedalShare;
	var AwardTextPos[8]={35,396,84,396,82,82,335,335};
	
	STRING* PlayerNames=str_create("Mr YellowMr PinkMr BlueMr Green");
	
	//Create Border
	CreateRectangle(bGameField, vector(5,30,0), vector(634,30,0), vector(5,474,0), vector(634,474,0), 4-Aindex, vector(0,0,206));

	
	while (i++<MAXPLAYERS)
	{
		vec_set(Player[i]->position[_X],vector(RandomInt(40,600),RandomInt(65,440),NULL));
		
		vec_set(Player[i]->velocity[_X],vector(0,0,NULL));
		
		Player[i]->angle=RandomInt(-180,180);
		
		Player[i]->alive=TRUE;
		
		if (Player[i]->owner!=OWNER_NONE) PlayerFunc(Player[i],i);
	}
	
	
	//Countdown Sound
	snd_play(sndCountDown, 100, 0);
		
	//Game Loop
	while (winnerId==-2)
	{
		//Music
		if (!media_playing(media_handle)) media_play(str_cat_num(str_cpy(TempString,""),"%.0f.mid",RandomInt(1,12)),NULL,100);
		
		if (total_ticks-startTime<3*19)
			draw_text(str_for_num (NULL, abs(integer((total_ticks-startTime)/19)-3)),317,5,vector(0,255,255));
		
		i=-1;
		winnerId=-1;
		while (i++<MAXPLAYERS)
		{
			if (Player[i]->owner!=OWNER_NONE)
				if (draw_text(str_cat_num(str_cat_num(GetNameFromPlayer(i,PlayerNames),": %.0f",Player[i]->roundsWon),"/%.0f",Rounds[Rindex]),PlayerData[i*MAXPLAYERDATA+PLAYERDATA_NAMEPOSX],7,PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]))
					if (Player[i]->alive)
						if (winnerId==-1)
							winnerId=i;
						else
							winnerId=-2;
		}
			
			
		if (winnerId>=0)
			if (Player[winnerId]->roundsWon++) Player[winnerId]->alive=FALSE;
		
		wait(1);
	}
	
	if (endTime=total_ticks)
		while (total_ticks-endTime<2*SecondInTicks)
		{
			if (winnerId>=0) draw_text(str_cat(GetNameFromPlayer(winnerId,PlayerNames)," Wins!"),265,7,PlayerData[winnerId*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
				else draw_text("Tie!",305,7,vector(0,128,255));
			wait(1);
		}
	
	
	if (winnerId==-1) NewMatch();
		else if (Player[winnerId]->roundsWon<Rounds[Rindex]) NewMatch();
			else
			{
				if (draw_textmode("Arial",1,30,100))
				if (i=Rounds[Rindex]+1)
					while (i-->=0)
					{
						if (j=-1)
							if ((MedalShare=-1) || 1)
								while (j++<MAXPLAYERS)
									if (Player[j].roundsWon==i && Player[j].owner!=OWNER_NONE)
										if (MedalShare++ || 1)
											if (Player[j].medal=Medal)
												if (Player[j].medalShare=MedalShare)
													if (Player[j].medalShare==2)
														Player[j].medalShare=-1;
						if (MedalShare!=-1) Medal++;
					}
				
				if (media_stop(media_handle) || 1)
				if (media_play("applause.ogg",NULL,10000))
				if (endTime=total_ticks)
					while (total_ticks-endTime<8*SecondInTicks)
					{
						if (draw_quad(bWinScreen,nullvector,NULL,NULL,NULL,NULL,100,0))
						if (i=-1)
							while (i++<MAXPLAYERS)
								if (Player[i].owner!=OWNER_NONE)
									draw_text(GetNameFromPlayer(i,PlayerNames),AwardTextPos[Player[i].medal-1],AwardTextPos[Player[i].medal-1+4]+Player[i].medalShare*30,PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
									
						wait(1);
					}
					
				DrawMainScreen();
			}
}


void ToggleRounds() {if (!MatchStarted) if (snd_play(sndSetting,100,0)) if (Rindex++>4) Rindex=0;}
void ToggleDifficulty() {if (!MatchStarted) if (snd_play(sndSetting,100,0)) if (Dindex++>4) Dindex=0;}
void ToggleAreaSize() {if (!MatchStarted) if (snd_play(sndSetting,100,0)) if (Aindex++>4) Aindex=0;}
void ToggleStart()
{
	if (!MatchStarted)
	{
		if (activePlayers<2)
		{ 
			snd_play(sndCantStartGame,100,0);
		}
		else if (media_stop(media_handle) || 1)
		{
			snd_play(sndStartGame,100,0);
			wait(-0.6);
			NewMatch();
			wait(1);
			MatchStarted=TRUE;
		}
	}
}

void HandleEscape()
{
	proc_kill(16);
	snd_stopall(4);
	if (MatchStarted) DrawMainScreen();
		else sys_exit("");
}

void DrawMainScreen()
{	
	//Menu Music
	if (media_stop(media_handle) || 1) media_loop("MeltyEyes.ogg",NULL,10000);

	int i=-1,bKeypress[MAXPLAYERS];
	STRING* sDifficulties=str_create("I Like my Lines SlowAre we there Yet?Just About RightMake it Stop!Impossible!");
	STRING* sAreaSizes=str_create("BabySmallMediumBigHumongous");
		
	while (i++<MAXPLAYERS)
		Player[i]->owner=OWNER_NONE;
	
	activePlayers=0;
	
	MatchStarted=FALSE;
	
	if (draw_textmode("Arial",1,20,100))
	while (!MatchStarted)
	{
		draw_quad(bMScreen,nullvector,NULL,NULL,NULL,NULL,100,0);
		
		draw_text(str_for_num(NULL,Rounds[Rindex]),415,284,vector(0,255,255));
		draw_text(str_trunc(str_clip(str_cpy(TempString,sDifficulties),Difficulty[Dindex*DLEVEL_MAX+DLEVEL_TEXTPOS]),str_len(sDifficulties)-Difficulty[Dindex*DLEVEL_MAX+DLEVEL_TEXTPOS]-(Difficulty[(Dindex+1)*DLEVEL_MAX+DLEVEL_TEXTPOS]-Difficulty[Dindex*DLEVEL_MAX+DLEVEL_TEXTPOS])),359,320,vector(255,0,255));
		draw_text(str_trunc(str_clip(str_cpy(TempString,sAreaSizes),AreaSize[Aindex]),str_len(sAreaSizes)-AreaSize[Aindex]-(AreaSize[Aindex+1]-AreaSize[Aindex])),356,354,vector(255,255,128));

		i=-1;
		while (i++<MAXPLAYERS)
		{
			if (key_pressed(PlayerData[i*MAXPLAYERDATA+PLAYERDATA_KEYFIRE]) && !bKeypress[i])
			{
				if (Player[i]->owner==OWNER_NONE) activePlayers++;
				
				if (bKeypress[i]=TRUE)
					if ((Player[i]->roundsWon=0) || 1)
						if (Player[i]->owner++>OWNER_COMPUTER) Player[i]->owner=OWNER_PLAYER;
				
				if (Player[i]->owner==OWNER_PLAYER) snd_play(sndPlayerSelect,100,0);
					else snd_play(sndComputerSelect,100,0);
			}
			
			if (!key_pressed(PlayerData[i*MAXPLAYERDATA+PLAYERDATA_KEYFIRE]))
				bKeypress[i]=FALSE;
			
			if (Player[i]->owner==OWNER_PLAYER)
				draw_text("Human",PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTX]+45,PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTY],PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			else if (Player[i]->owner==OWNER_COMPUTER)
				draw_text("Computer",PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTX]+34,PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTY],PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			else
				draw_text("Press Fire to Join!",PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTX],PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTY],PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
		}
			
		wait(1);
	}
}



void main()
{	
	//Create MainScreen Bitmap and Sounds
	if (sndCountDown=snd_create("countdown.ogg"))
		if (sndCrash=snd_create("crash.ogg"))
			if (sndPlayerSelect=snd_create("joinPlr.wav"))
				if (sndComputerSelect=snd_create("joinComp.wav"))
					if (sndSetting=snd_create("select.wav"))
						if (sndStartGame=snd_create("Enter.wav"))
							if (sndCantStartGame=snd_create("noEnter.wav"))
								if (on_f1=ToggleRounds)
									if (on_f2=ToggleDifficulty)
										if (on_f3=ToggleAreaSize)
											if (on_space=ToggleStart)
												if (TempString=str_create(""))
													if (bWinScreen=bmap_create("Winnerscreen.jpg"))
														bMScreen=bmap_create("Mainscreen.jpg");
	
	//Inits
	if (randomize() || video_switch (6,16,1)) mouse_pointer=0;
	
	
	//Create Players
	int i=-1;
	while (i++<MAXPLAYERS)
		Player[i]=malloc(sizeof(PLAYER));
	
	wait(1);
	on_f5=NULL;
	on_esc=HandleEscape;
	
	DrawMainScreen();
}


